package org.ugasp.impl.connector.socket;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketOptions;
import java.util.Iterator;
import java.util.Vector;

import org.ugasp.connector.*;
import org.ugasp.service.external.admin.AdminConnector;
import org.ugasp.service.external.player.PlayerConnector;


public class SocketServer implements Connector, Runnable{
	//iPojo dynamic binding fields
    private PlayerConnector playerConnector;
    private AdminConnector adminConnector;
	
	//uGASP socket params
	private final static int PORT = 9740;
	private final static int MAX_CONNECTIONS = 50000;
	private ServerSocket serverSocket;
	private Vector clients = new Vector();
	private Thread thread;
	
	private int nbConnections = 0;
	
	public SocketServer() throws IOException {
		System.out.println("Socket Server instantiated");			
	}
	
	public void run() {
		try{
			while(nbConnections < MAX_CONNECTIONS){
				System.out.println("Number of socket clients: "+clients.size());
				checkClientManagerStatus();
				
				Socket socket = serverSocket.accept();
				
				System.out.println("Incoming socket connection request from "+socket.getInetAddress().getHostAddress());
				
				// to avoid TCP wait on small packets
				socket.setTcpNoDelay(true);
				
				/*boolean socketExist = false;
				
				for(int i=0; i<clients.size(); i++){
					ClientManager client = ((ClientManager) clients.get(i));
					if (client.socket.getInetAddress().equals(socket.getInetAddress())){
						client.changeSocket(socket);
						socketExist = true; 
						break;
					}	
				}
				
				if (!socketExist){*/
				ClientManager client = new ClientManager(adminConnector, playerConnector, socket);
				clients.addElement(client);
				nbConnections++;
				
				/*}*/
			}			
		}
		catch(Exception e){}
	}
	
	private void checkClientManagerStatus() {
		for(Iterator iter = clients.iterator(); iter.hasNext();){
			ClientManager client = (ClientManager) iter.next();
			if (client.socket == null){
				iter.remove();
				nbConnections--;
				System.out.println("SocketServer: removing connection for host "+client.getHostname());
			}
		
		}
	}

	public void start(){
		try {
			serverSocket = new ServerSocket(PORT);

			System.out.println("SocketServer start to listen on port: "+PORT);
			thread = new Thread(this);
			thread.start();
		} catch (IOException e) {
			System.out.println("SocketServer: error occured on port opening");
			e.printStackTrace();
		}
		
	}
	
	public void stop() {
		try {
			// close all socket streams with clients
			System.out.println("SocketServer:try to close socket streams");
			
			for(int i=0; i<clients.size(); i++){
				((ClientManager) clients.get(i)).stop();
			}
			
			checkClientManagerStatus();
			
			serverSocket.close();
		} 
		catch (Exception e) {
			System.out.println("Could not close the Socket connector: "+e.getMessage());
		}
		System.out.println("SocketServer: end close");
	}
}
