/***
 * uGASP: an OSGi middleware dedicated to ubiquitous multiplayer gaming.
 * Copyright (C) 2008 CNAM/INT
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contact: gasp-team@objectweb.org
 *
 * Author: Romain Pellerin
 */
package org.ugasp.protocol.osc;

/**
 * This interface represents the OSC message functionalities.
 * 
 * 
 * @author PELLERIN Romain (romain.pellerin@cnam.fr, romain.pellerin@gmail.com)
 */
public interface OSCMessage extends OSCPacket{
	
	/**
	 * The receiver of this message.
	 * @return the receiver of this OSC Message
	 */
	public String getAddress();
	
	/**
	 * Set the address of this messsage.
	 * @param anAddress the receiver of the message
	 */
	public void setAddress(String anAddress);
	
	/**
	 * Add an argument to the list of arguments.
	 * @param argument a Float, String, Integer, BigInteger, Boolean or array of these
	 */	
	public void addArgument(Object argument);
	
	/**
	 * The arguments of this message.
	 * @return the arguments to this message
	 */		
	public Object[] getArguments();
}
