/***
 * uGASP: an OSGi middleware dedicated to ubiquitous multiplayer gaming.
 * Copyright (C) 2008 CNAM/INT
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contact: gasp-team@objectweb.org
 *
 * Author: Romain Pellerin
 */
package org.ugasp.service.internal.gameserver.location;

public interface MapProvider {
	
	/**
	 * Gets the map from a map provider and returns the map data as a byte array.
	 * 
	 * @param devID - developer ID (often required by map providers)
	 * @param lat - GPS latitude
	 * @param lon - GPS longitude
	 * @param screen_width
	 * @param screen_height
	 * @param zoom - map zoom
	 * @return map data
	 */
	public byte[] getMap(String devID, double lat, double lon, int screen_width, int screen_height, int zoom);
	
}
