package org.ugasp.service.internal.gameserver.rfid;

import java.util.Hashtable;

public interface RFIDData {
	
	// returns the unique identifier of the associated tag
	public String getUID();

	// returns the type of location data
	byte getLocationType();

	// returns the GPS latitude / longitude of the tag
	double[] getGPSCoordinates();
	
	// returns the custom location infos
	Hashtable getCustomLocationInfos();
	
	// returns the game event associated to the tag reading
	public Hashtable getGameEvents();
	
	// returns the list of game objects associated to the tag
	public Hashtable getGameObjects();
	
	// returns some custom data
	public Hashtable getCustomData();

}
